<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "crawler_provider_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CrawlerProviderPractice".
 *
 * Columns in table "crawler_provider_practice" available as properties of the model,
 * followed by relations of table "crawler_provider_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $crawler_provider_id
 * @property integer $is_primary
 * @property string $name
 * @property string $street1
 * @property string $street2
 * @property string $address
 * @property string $address_2
 * @property string $phone_number
 * @property string $zipcode
 * @property string $city
 * @property string $state
 * @property double $latitude
 * @property double $longitude
 * @property string $crawler_practice_guid
 * @property string $date_added
 * @property string $date_updated
 *
 * @property CrawlerProvider $crawlerProvider
 */
abstract class BaseCrawlerProviderPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'crawler_provider_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CrawlerProviderPractice|CrawlerProviderPractices', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('crawler_provider_id, is_primary, date_added', 'required'),
            array('crawler_provider_id, is_primary', 'numerical', 'integerOnly' => true),
            array('latitude, longitude', 'numerical'),
            array('name', 'length', 'max' => 150),
            array('street1, street2, address, address_2', 'length', 'max' => 254),
            array('phone_number', 'length', 'max' => 14),
            array('zipcode', 'length', 'max' => 10),
            array('city, state', 'length', 'max' => 50),
            array('crawler_practice_guid', 'length', 'max' => 40),
            array('date_updated', 'safe'),
            array(
                'name, street1, street2, address, address_2, phone_number, zipcode, city, state, latitude, longitude, 
                    crawler_practice_guid, date_updated', 
                'default', 
                'setOnEmpty' => true, 
                'value' => null
            ),
            array(
                'id, crawler_provider_id, is_primary, name, street1, street2, address, address_2, phone_number, zipcode, 
                    city, state, latitude, longitude, crawler_practice_guid, date_added, date_updated', 
                'safe', 
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'crawlerProvider' => array(self::BELONGS_TO, 'CrawlerProvider', 'crawler_provider_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'crawler_provider_id' => null,
            'is_primary' => Yii::t('app', 'Is Primary'),
            'name' => Yii::t('app', 'Name'),
            'street1' => Yii::t('app', 'Street1'),
            'street2' => Yii::t('app', 'Street2'),
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'zipcode' => Yii::t('app', 'Zipcode'),
            'city' => Yii::t('app', 'City'),
            'state' => Yii::t('app', 'State'),
            'latitude' => Yii::t('app', 'Latitude'),
            'longitude' => Yii::t('app', 'Longitude'),
            'crawler_practice_guid' => Yii::t('app', 'Crawler Practice Guid'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'crawlerProvider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('crawler_provider_id', $this->crawler_provider_id);
        $criteria->compare('is_primary', $this->is_primary);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('street1', $this->street1, true);
        $criteria->compare('street2', $this->street2, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('zipcode', $this->zipcode, true);
        $criteria->compare('city', $this->city, true);
        $criteria->compare('state', $this->state, true);
        $criteria->compare('latitude', $this->latitude);
        $criteria->compare('longitude', $this->longitude);
        $criteria->compare('crawler_practice_guid', $this->crawler_practice_guid, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
